<template>
<section>
    <div class="container">
        <div class="row">
            <div class="shadow col-12 mt-4 p-3 mb-5 bg-white rounded">
                <div class="float-left">
                    <a href="javascript:window.history.go(-1);"><i class="material-icons">arrow_back_ios</i> Regresar</a>
                </div>
                <h2 class="text-center">Directores</h2>
            </div>
        </div>
        <div class="row shadow" style="border-radius: 5px">
            <div v-if="listaDirectores.length === 0">
                <div class="alert alert-danger" role="alert" v-if="listaDirectores.length === 0">
                    <h2 class="lead">No se cuenta con docentes registrados</h2>
                </div>
            </div>
        </div>
        <div class="row align-items-start">
            <b-button variant="primary" size="lg" id="show-btn" @click="showModal('modal-registrar')" v-b-tooltip.hover title="Agregar registro"><i class="material-icons">person_add</i></b-button>
        </div>
        <br>
        <div class="row shadow-lg">
            <br>
            <table v-show="listaDirectores.length > 0" class="table table-hover table-light">
                <thead>
                    <tr style="background-color: #019979">
                        <!-- <th scope="col">#</th> -->
                        <th scope="col" class="text-white lead">NOMBRE COMPLETO</th>
                        <th scope="col" class="text-white lead">CORREO INSTITUCIONAL</th>

                        <th scope="col" class="text-white lead">CÉDULA</th>
                        <th scope="col" class="text-white lead">CURP</th>
                        <th scope="col" class="text-white lead" style="text-align:center;">ACCIONES</th>
                    </tr>
                </thead>
                <tbody>
                    <tr v-for="(director, index) in listaDirectores" :key="index" class="table-light lead">
                        <!-- <th scope="row">{{index}}</th> -->
                        <td>{{director.nombre}} {{director.primerApellido}} {{director.segundoApellido}}</td>
                        <td>{{director.correoInstitucional}}</td>
                        <td>{{director.cedula}}</td>
                        <td>{{director.curp}}</td>
                        <td>
                            <b-button variant="info" style="margin-right:20px;" id="show-btn" @click="showModal('modal-vermas'); llenarObjetoDirector(director)" v-b-tooltip.hover title="Ver más información"><i class="material-icons">visibility</i></b-button>
                            <b-button variant="warning" style="margin-right:20px;" id="show-btn" @click="showModal('modal-modificar'); llenarObjetoDirector(director)" v-b-tooltip.hover title="Modificar información"><i class="material-icons">create</i></b-button>
                            <b-button variant="danger" id="show-btn" @click="eliminar(director.id)"><i class="material-icons" v-b-tooltip.hover title="Eliminar registro">delete</i></b-button>
                        </td>
                    </tr>
                </tbody>
            </table>
        </div>
        <!-- MODAL REGISTRAR -->
        <b-modal ref="modal-registrar" hide-footer title="Directores académicos" size="lg">
          <div class="d-block text-center">
            <b-form @submit="formRegistrar">

                <!--Campo nombre-->
                <div class="form-group">
                    <b-form-input type="text" :state="nameValid"  v-model="nombre" placeholder="Nombre(s)" required />
                    <b-form-invalid-feedback :state="nameValid">
                        Ingresa al menos 4 letras
                    </b-form-invalid-feedback>
                </div>

                 <!--Campos Apellidos-->
                <div class="row form-group">
                    <div class="col">
                        <b-form-input type="text" class="form-control" v-model="primerApellido" :state="firstNameValid" required placeholder="Primer apellido" />
                        <b-form-invalid-feedback :state="firstNameValid">
                            Ingresa al menos 4 letras.
                        </b-form-invalid-feedback>
                    </div>

                    <div class="col">
                        <b-form-input type="text" class="form-control" v-model="segundoApellido" :state="secondNameValid" required placeholder="Segundo apellido" />
                        <b-form-invalid-feedback :state="secondNameValid">
                            Ingresa al menos 4 letras.
                        </b-form-invalid-feedback>
                    </div>
                </div>

                <!--Genero-->
                <div class="form-group">
                    <label for>Género</label>
                    <b-form-select class="form-control" v-model="genero" :state="gengerValid" required>
                        <option value="Femenino">Femenino</option>
                        <option value="Masculino">Masculino</option>
                        <option value="Otro">Otro</option>
                    </b-form-select>
                    <b-form-invalid-feedback :state="gengerValid">
                        Seleccione una opcion.
                    </b-form-invalid-feedback>
                </div>

                <!--CURP-->
                <div class="form-group">
                    <b-form-input type="text" v-model="curp" class="form-control" placeholder="CURP" :state="curpValid" @keyup="limitar()" required/>
                    <b-form-invalid-feedback :state="curpValid">
                        Ingresa tu CURP, 18 dígitos.  
                    </b-form-invalid-feedback>
                    <small>
                        <a href="https://www.gob.mx/curp/" target="_blank" >Consultar CURP</a>
                    </small>
                </div>

                <!--Correos-->
                <div class="row form-group">
                    <div class="col">
                        <input type="email" v-model="correoInstitucional" class="form-control" placeholder="Correo electrónico institucional" required/>
                        <b-form-text>
                            Verifica el formato: ejemplo@utez.edu.mx
                        </b-form-text>
                    </div>
                    <div class="col">
                        <input type="email" v-model="correoPersonal" class="form-control" placeholder="Correo personal" required/>
                        <b-form-text>
                            Verifica el formato: ejemplo@ejemplo.com
                        </b-form-text>
                    </div>
                </div>

                <!--Nivel Estudios-->
                <div class="row form-group">
                    <div class="col">
                        <label for>Nivel maximo de estudios</label>
                        <b-form-select v-model="nivelMax" class="form-control" required :state="nivelValid" >
                            <option value="Preparatoria">Preparatoria</option>
                            <option value="Licenciatura">Licenciatura</option>
                            <option value="Ingenieria">Ingenieria</option>
                            <option value="Post-grado">Post-grado</option>
                            <option value="Maestria">Maestria</option>
                            <option value="Doctorado">Doctorado</option>
                        </b-form-select>
                        <b-form-invalid-feedback :state="nivelValid">
                            Seleccione una opcion  
                        </b-form-invalid-feedback>
                    </div>

                    <div class="col">
                        <label for>Cedula profesional</label>
                        <b-form-input v-model="cedula" type="text" class="form-control" required :state="cedulaValid" @keyup="limitCed" />
                        <b-form-invalid-feedback :state="cedulaValid">
                            Ingresa tu Cédula, 8 dígitos.
                        </b-form-invalid-feedback>
                    </div>

                </div>

                <!--Titulo Academico-->
                <div class="form-group">
                    <b-form-input type="text" class="form-control" v-model="titulo" placeholder="Título académico" required :state="tituloValid"/>
                    <b-form-invalid-feedback :state="tituloValid">
                        Ingrese al menos 3 letras 
                    </b-form-invalid-feedback>
                </div>

                <!--Semblanza-->
                <div class="form-group">
                    <label for>Semblanza</label>
                    <b-form-textarea name class="form-control" v-model="semblanza" cols="10" rows="5" required :state="semblanzaValid"></b-form-textarea>
                    <b-form-invalid-feedback :state="semblanzaValid">
                        Describete en al menos 10 palabras. 
                    </b-form-invalid-feedback>
                </div>

                <!--Division Academica-->
                <div class="row form-group">
                    <div class="col">
                        <label for>División académica</label>
                        <b-form-select v-model="division" class="form-control" :state="diviValid" required>
                            <option v-for="division in listas.response.listaDivicion" :key="division.id" :value="division.id" >
                                {{division.nombreDivicion}}
                            </option>
                        </b-form-select>
                        <b-form-invalid-feedback :state="diviValid">
                            Seleccione una opcion. 
                        </b-form-invalid-feedback>
                    </div>

                    <div class="col">
                        <label for>Tipo de horario</label>
                        <b-form-select v-model="tipoHorario" class="form-control" :state="tiempoValid" required>
                            <option v-for="tipoHorario in listas.response.listaTiempo" :key="tipoHorario.id" :value="tipoHorario.id">
                                {{tipoHorario.nombreTiempo}}
                            </option>
                        </b-form-select>
                        <b-form-invalid-feedback :state="tiempoValid">
                            Seleccione una opcion. 
                        </b-form-invalid-feedback>
                    </div>
                </div>
                <!--Telefonos-->
                <div class="row form-group">
                    <div class="col">
                        <label for>Teléfono de casa</label>
                        <b-form-input class="form-control" type="text" placeholder="(777) 123-45-67" v-model="telCasa" :state="telCasaValid" required />
                        <b-form-invalid-feedback :state="telCasaValid">
                            Debes ingresar 10 dígitos
                        </b-form-invalid-feedback>
                    </div>

                    <div class="col">
                        <label for>Teléfono movil</label>
                        <b-form-input class="form-control" type="text" placeholder="(777) 123-45-67" v-model="telMovil" required :state="telefonoMovil"/>
                        <b-form-invalid-feedback :state="telefonoMovil">
                            Debes ingresar 10 dígitos
                        </b-form-invalid-feedback>
                    </div>
                </div>
              <b-button  type="submit" block variant="outline-success">Registrar</b-button>
            </b-form>
          </div>
          <b-button class="mt-3" variant="outline-danger" block @click="hideModal('modal-registrar')">Cancelar</b-button>
        </b-modal>
        <!-- MODAL MODIFICAR -->
        <b-modal ref="modal-modificar" hide-footer title="Modificar director" size="lg">
          <div class="d-block text-center">
              <form @submit="modificarDirector">
                  <!--Nombre-->
                <div class="form-group">
                    <b-form-input type="text" class="form-control" v-model="objDirector.nombre" placeholder="Nombre(s)" :state="nameValid" required />
                    <b-form-invalid-feedback :state="nameValid">
                        Ingresa al menos 4 letras
                    </b-form-invalid-feedback>
                </div>
                <!--apellidos-->
                <div class="row form-group">
                    <div class="col">
                        <input type="text" class="form-control" v-model="objDirector.primerApellido" placeholder="Primer apellido" required />
                    </div>
                    <div class="col">
                        <input type="text" class="form-control" v-model="objDirector.segundoApellido" placeholder="Segundo apellido" required />
                    </div>
                </div>
                <!--Genero-->
                <div class="form-group">
                    <label for>Género</label>
                    <select class="form-control" v-model="objDirector.sexo" required>
                        <option value="Femenino">Femenino</option>
                        <option value="Masculino">Masculino</option>
                        <option value="Otro">Otro</option>
                    </select>
                </div>
                <!--CURP-->
                <div class="form-group">
                    <input type="text" v-model="objDirector.curp" class="form-control" placeholder="CURP" required />
                    <small>
                        <a href="https://www.gob.mx/curp/" target="_blank">Consultar CURP</a>
                    </small>
                </div>
                <!--Correos-->
                <div class="row form-group">
                    <div class="col">
                        <input type="email" v-model="objDirector.correoInstitucional" class="form-control" placeholder="Correo electrónico institucional" required />
                    </div>
                    <div class="col">
                        <input type="email" v-model="objDirector.correoPersonal" class="form-control" placeholder="Correo personal" required/>
                    </div>
                </div>
                <!--Nivel Estudios-->
                <div class="row form-group">
                    <div class="col">
                        <label for>Nivel maximo de estudios</label>
                        <select v-model="objDirector.nivelMaximo" class="form-control" required>
                            <option value="Preparatoria">Preparatoria</option>
                            <option value="Licenciatura">Licenciatura</option>
                            <option value="Ingenieria">Ingenieria</option>
                            <option value="Post-grado">Post-grado</option>
                            <option value="Maestria">Maestria</option>
                            <option value="Doctorado">Doctorado</option>
                        </select>
                    </div>
                    <div class="col">
                        <label for>Cedula profesional</label>
                        <input v-model="objDirector.cedula" type="text" class="form-control" required />
                    </div>
                </div>
                <!--Titulo-->
                <div class="form-group">
                    <input type="text" class="form-control" v-model="objDirector.titulo" placeholder="Título académico" required />
                </div>
                <!--Semblanza-->
                <div class="form-group">
                    <label for>Semblanza</label>
                    <textarea name class="form-control" v-model="objDirector.semblanza" cols="10" rows="5" required></textarea>
                </div>
                <!--Division-->
                <div class="row form-group">
                    <div class="col">
                        <label for>División académica</label>
                        <select v-model="objDirector.divicionTrabajadorId" class="form-control" required>
                            <option v-for="division in listas.response.listaDivicion" :key="division.id" :value="division.id">
                                {{division.nombreDivicion}}
                            </option>
                        </select>
                    </div>
                    <div class="col">
                        <label for>Tipo de horario</label>
                        <select v-model="objDirector.tiempoTrabajadorId" class="form-control" required>
                            <option v-for="tipoHorario in listas.response.listaTiempo" :key="tipoHorario.id" :value="tipoHorario.id">
                                {{tipoHorario.nombreTiempo}}
                            </option>
                        </select>
                    </div>
                </div>
                <!--telefonos-->
                <div class="row form-group">
                    <div class="col">
                        <label for>Teléfono de casa</label>
                        <input class="form-control" type="text" placeholder="(777) 123-45-67" v-model="objDirector.telefonoCasa" required />
                    </div>
                    <div class="col">
                        <label for>Teléfono móvil</label>
                        <input class="form-control" type="text" placeholder="(777) 123-45-67" v-model="objDirector.telefonoMovil" required/>
                    </div>
                </div>
                    <b-button block type="submit" variant="outline-success">Modificar</b-button>
                </form>
          </div>
          <b-button class="mt-3" variant="outline-danger" block @click="hideModal('modal-modificar'); obtenerDirectores();">Cerrar</b-button>
        </b-modal>
        <!-- MODAL VER MÁS -->
        <b-modal ref="modal-vermas" hide-footer title="Información Personal">
          <div class="d-block text-justify">
              <p><strong>Nombre:</strong> {{objDirector.nombre}} {{objDirector.primerApellido}} {{objDirector.segundoApellido}}</p>
              <p> <strong>Cédula:</strong> {{objDirector.cedula}}</p>
              <p> <strong>Correo institucional:</strong> {{objDirector.correoInstitucional}}</p>
              <p> <strong>Correo personal:</strong> {{objDirector.correoPersonal}}</p>
              <p><strong>CURP:</strong> {{objDirector.curp}}</p>
              <div v-for="division in listas.response.listaDivicion" :key="division.id">
                <p v-show="division.id == objDirector.divicionTrabajadorId">
                    <strong>División académica: </strong>{{division.nombreDivicion}}
                </p>
            </div>
            <p><strong>Nivel máximo de estudios: </strong>{{objDirector.nivelMaximo}}</p>
            <div v-for="tiempo in listas.response.listaTiempo" :key="tiempo.id">
                <p v-show="tiempo.id == objDirector.tiempoTrabajadorId">
                    <strong>Tiempo: </strong>{{tiempo.nombreTiempo}}
                </p>
              </div>
              <p><strong>Semblanza:</strong> {{objDirector.semblanza}}</p>
              <p><strong>Sexo:</strong> {{objDirector.sexo}}</p>
              <p><strong>Teléfono casa:</strong> {{objDirector.telefonoCasa}}</p>
              <p><strong>Teléfono celular:</strong> {{objDirector.telefonoMovil}}</p>       
          </div>
          <b-button class="mt-3" variant="outline-danger" block @click="hideModal('modal-vermas'); obtenerDirectores();">Cerrar</b-button>
        </b-modal>
    </div>
  </section>
</template>

<script>
import axios from "axios";
import {server} from '../../store'
import {functions} from "../../functionsGolbals";

export default {
    mixins: [functions],
    data() {
        return {
            objDirector: [],
            listas: [],
            listaDirectores: [],
            output: null,
            nombre: '',
            primerApellido: '',
            segundoApellido: '',
            genero: '',
            curp: '',
            correoInstitucional: '',
            correoPersonal: '',
            nivelMax: '',
            cedula: '',
            titulo: '',
            semblanza: '',
            division: '',
            tipoHorario: '',
            telCasa: '',
            telMovil: ''
        }
    },
    computed:{
        nameValid(){
            if(this.nombre.length == 0)return null;
            if(this.nombre.length > 3) return true;
            else return false; 
        },
        firstNameValid(){
            if(this.primerApellido.length == 0) return null;
            if(this.primerApellido.length > 3) return true;
            else return false;


        },
        secondNameValid(){
            if(this.segundoApellido.length == 0)return null;
            if(this.segundoApellido.length > 3) return true;
            else return false;
        },
        gengerValid(){
            if(this.genero == '')return null;
            else return true;
        },
        curpValid(){
            if(this.curp.length == 0)return null;
            if(this.curp.length == 18)return true;
            else return false;
        },
        nivelValid(){
            if(this.nivelMax == '')return null;
            else return true;
        },
        cedulaValid(){
            if(this.cedula.length == 0) return null;
            if(this.cedula.length == 8)return true;
            else return false;
        },
        tituloValid(){
            if(this.titulo.length == 0)return null;
            if(this.titulo.length > 2)return true;
            else return false;
        },
        semblanzaValid(){
            if(this.semblanza.length == 0) return null;
            if(this.semblanza.length > 10) return true;
            else return false;
        },
        diviValid(){
            if(this.division == '')return null;
            else return true;
        },
        tiempoValid(){
            if(this.tipoHorario == '')return null;
            else return true;
        },
        telCasaValid(){
            if(this.telCasa.length == 0)return null;
            if(this.telCasa.length == 10) return true;
            else return false;
        },
        telefonoMovil(){
            if(this.telMovil.length == 0)return null;
            if(this.telMovil.length == 10) return true;
            else return false;
        }
    },
    mounted() {
        if(localStorage.getItem('usuario') == null){
          this.$router.push("/login");
        }
        this.obtenerListas();
        this.obtenerDirectores();
    },
    methods: {
        llenarObjetoDirector: function (director) {
            this.objDirector = director
        },
        obtenerListas() {
            axios
                .get(`${server.baseURL}/api/trabajador/listas`)
                .then(data => (this.listas = data.data));
        },
        obtenerDirectores() {
            axios
                .get(`${server.baseURL}/api/trabajador/listaDirectores`)
                .then(data => (this.listaDirectores = data.data));
        },
        formRegistrar(e) {
            e.preventDefault();
            let currentObj = this;
            axios.post(`${server.baseURL}/api/trabajador/registro`, {
                    trabajador: {
                        nombre: this.nombre,
                        primerApellido: this.primerApellido,
                        segundoApellido: this.segundoApellido,
                        correoInstitucional: this.correoInstitucional,
                        correoPersonal: this.correoPersonal,
                        cedula: this.cedula,
                        nivelMaximo: this.nivelMax,
                        titulo: this.titulo,
                        telefonoCasa: this.telCasa,
                        telefonoMovil: this.telMovil,
                        curp: this.curp,
                        semblanza: this.semblanza,
                        sexo: this.genero,
                        tiempoId: this.tipoHorario,
                        divicionId: this.division,
                        rol: 2
                    }
                })
                .then(function (response) {
                    currentObj.output = response.data;
                    currentObj.obtenerDirectores();
                    currentObj.hideModal('modal-registrar');
                    currentObj.alertSuccess(currentObj.output.response.message);
                    // this.$swal('Heading', 'this is a Heading', 'OK');
                })
                .catch(function (error) {
                    currentObj.output = error;
                    currentObj.hideModal(currentObj.output.response.message);
                    currentObj.alertError(currentObj.output.response.message);
                });
        },
        modificarDirector(e) {
            e.preventDefault();
            let currentObj = this;
            axios.post(`${server.baseURL}/api/trabajador/modificacionDivision`, {
                    trabajador: {
                        id: this.objDirector.id,
                        idDivision: this.objDirector.divicionTrabajadorId,
                        nombre: this.objDirector.nombre,
                        primerApellido: this.objDirector.primerApellido,
                        segundoApellido: this.objDirector.segundoApellido,
                        correoInstitucional: this.objDirector.correoInstitucional,
                        correoPersonal: this.objDirector.correoPersonal,
                        cedula: this.objDirector.cedula,
                        nivelMaximo: this.objDirector.nivelMaximo,
                        titulo: this.objDirector.titulo,
                        telefonoCasa: this.objDirector.telefonoCasa,
                        telefonoMovil: this.objDirector.telefonoMovil,
                        estado: "activo",
                        semblanza: this.objDirector.semblanza,
                        sexo: this.objDirector.sexo,
                        tiempoTrabajadorId: this.objDirector.tiempoTrabajadorId,
                    }
                })
                .then(function (response) {
                    currentObj.output = response.data;
                    currentObj.obtenerDirectores();
                    currentObj.hideModal('modal-modificar');
                    currentObj.alertSuccess(currentObj.output.response.message);
                })
                .catch(function (error) {
                    currentObj.output = error;
                    currentObj.hideModal('modal-modificar');
                    currentObj.alertError(currentObj.output.response.message);
                });
        },
        eliminar(id){
            let currentObj = this;
            axios.post(`${server.baseURL}/api/trabajador/eliminar`, {
                    eliminar: {
                        id: id
                    }
                })
                .then(function (response) {
                    currentObj.output = response.data;
                    currentObj.obtenerDirectores();
                    currentObj.alertSuccess(currentObj.output.response.message);
                })
                .catch(function (error) {
                    currentObj.output = error;
                    currentObj.alertError(currentObj.output.response.message);
                });
        },    
        limitar(){         
            if(this.curp.length >= 18){
                this.curp=this.curp.substring(0,18);        
            }     
        },
        limitCed(){
            if(this.cedula.length >= 8){
                this.cedula=this.cedula.substring(0,8);        
            }
        }
    }
}
</script>
